<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph/Core/String.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="classes.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
    </ul>
  </div>
<h1>Sylph/Core/String.h</h1><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> * LibSylph Class Library</span>
<a name="l00003"></a>00003 <span class="comment"> * Copyright (C) 2009 Frank "SeySayux" Erens &lt;seysayux@gmail.com&gt;</span>
<a name="l00004"></a>00004 <span class="comment"> *</span>
<a name="l00005"></a>00005 <span class="comment"> * This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment"> * modify it under the terms of the LibSylph Pulbic License as published</span>
<a name="l00007"></a>00007 <span class="comment"> * by the LibSylph Developers; either version 1.0 of the License, or</span>
<a name="l00008"></a>00008 <span class="comment"> * (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"> *</span>
<a name="l00010"></a>00010 <span class="comment"> * This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the LibSylph</span>
<a name="l00013"></a>00013 <span class="comment"> * Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * You should have received a copy of the LibSylph Public License</span>
<a name="l00016"></a>00016 <span class="comment"> * along with this Library, if not, contact the LibSylph Developers.</span>
<a name="l00017"></a>00017 <span class="comment"> *</span>
<a name="l00018"></a>00018 <span class="comment"> * Created on: 26 november 2008</span>
<a name="l00019"></a>00019 <span class="comment"> */</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef STRING_H_</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define STRING_H_</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include "Object.h"</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include "<a class="code" href="_comparable_8h.html" title="Include this file if you want your objects to be comparable with operator&amp;lt; ,…...">Comparable.h</a>"</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include "Hash.h"</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include "Primitives.h"</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include "Array.h"</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// for convenience</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include "I18N.h"</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;cstdint&gt;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 SYLPH_BEGIN_NAMESPACE
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 SYLPH_PUBLIC
<a name="l00039"></a>00039 
<a name="l00043"></a><a class="code" href="namespace_sylph.html#12380d58a638ec489736d7b60963a34c">00043</a> <span class="keyword">typedef</span> std::uint16_t <a class="code" href="namespace_sylph.html#12380d58a638ec489736d7b60963a34c" title="A integral type for storing an UTF-16 character.">uchar</a>;
<a name="l00044"></a>00044 
<a name="l00059"></a><a class="code" href="namespace_sylph.html#5aa3c7bde7827380a2a4012e43b1e901">00059</a> <span class="keyword">static</span> <a class="code" href="class_sylph_1_1_array.html">Array&lt;uchar&gt;</a> <a class="code" href="namespace_sylph.html#5aa3c7bde7827380a2a4012e43b1e901" title="This array contains the characters that are considered to be whitespace characters...">spacechars</a> = {<span class="charliteral">' '</span>, <span class="charliteral">'\n'</span>, <span class="charliteral">'\r'</span>, <span class="charliteral">'\f'</span>, <span class="charliteral">'\t'</span>, <span class="charliteral">'\013'</span>};
<a name="l00060"></a>00060 
<a name="l00080"></a><a class="code" href="class_sylph_1_1_string.html">00080</a> <span class="keyword">class </span><a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="code" href="class_sylph_1_1_object.html" title="The root of all classes.">Object</a> {
<a name="l00081"></a>00081     <span class="keyword">friend</span> <span class="keywordtype">bool</span> <a class="code" href="namespace_sylph.html#10c329a0349416d794bedf8f67feb25f" title="Compares the two Arrays on equality.">operator==</a>(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> lhs, <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> rhs);
<a name="l00082"></a>00082     <span class="keyword">friend</span> <span class="keywordtype">bool</span> <a class="code" href="namespace_sylph.html#049ea1ef37b015ca0292637e6d2e3ffa" title="Compares the two Arrays.">operator&lt;</a>(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> lhs, <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> rhs);
<a name="l00083"></a>00083     <span class="keyword">friend</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> operator+(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> lhs, <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> rhs);
<a name="l00084"></a>00084     <span class="comment">//friend String operator%(const String lhs, const String rhs);</span>
<a name="l00085"></a>00085     <span class="keyword">friend</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> operator&amp;(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> lhs, <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a>(*rhs)(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a>));
<a name="l00086"></a>00086     <span class="keyword">friend</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> operator&amp;(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a>(*lhs)(<a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a>), <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> rhs);
<a name="l00087"></a>00087     <span class="keyword">friend</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> operator*(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> lhs, <span class="keyword">const</span> std::size_t len);
<a name="l00088"></a>00088     <span class="keyword">friend</span> std::ostream &amp; operator&lt;&lt;(std::ostream&amp; lhs, <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> rhs);
<a name="l00089"></a>00089 
<a name="l00090"></a>00090     <span class="keyword">friend</span> <span class="keyword">struct </span>Hash&lt;String&gt;;
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 <span class="keyword">public</span>:
<a name="l00100"></a>00100     String();
<a name="l00117"></a>00117     String(<span class="keyword">const</span> <span class="keywordtype">char</span> * orig);
<a name="l00118"></a>00118 
<a name="l00129"></a>00129     String(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_array.html">Array&lt;uchar&gt;</a> orig);
<a name="l00137"></a>00137     String(<span class="keyword">const</span> std::string &amp; orig);
<a name="l00147"></a>00147     String(<span class="keyword">const</span> String &amp; orig);
<a name="l00153"></a>00153     String(<span class="keyword">const</span> <a class="code" href="namespace_sylph.html#12380d58a638ec489736d7b60963a34c" title="A integral type for storing an UTF-16 character.">uchar</a> c);
<a name="l00161"></a>00161     String(<span class="keyword">const</span> <span class="keywordtype">bool</span> b);
<a name="l00162"></a>00162 
<a name="l00172"></a>00172     String(<span class="keyword">const</span> sint i);
<a name="l00180"></a>00180     String(<span class="keyword">const</span> suint i);
<a name="l00190"></a>00190     String(<span class="keyword">const</span> slong l);
<a name="l00198"></a>00198     String(<span class="keyword">const</span> sulong l);
<a name="l00238"></a>00238     String(<span class="keyword">const</span> <span class="keywordtype">float</span> f);
<a name="l00278"></a>00278     String(<span class="keyword">const</span> <span class="keywordtype">double</span> d);
<a name="l00284"></a>00284     <span class="keyword">virtual</span> ~String();
<a name="l00285"></a>00285 
<a name="l00292"></a>00292     std::size_t length() <span class="keyword">const</span>;
<a name="l00293"></a>00293 
<a name="l00301"></a>00301     <span class="keyword">const</span> <a class="code" href="namespace_sylph.html#12380d58a638ec489736d7b60963a34c" title="A integral type for storing an UTF-16 character.">uchar</a> at(std::size_t idx) <span class="keyword">const</span>;
<a name="l00302"></a>00302 
<a name="l00317"></a>00317     <span class="keyword">const</span> <span class="keywordtype">char</span> * ascii() <span class="keyword">const</span>;
<a name="l00331"></a>00331     <span class="keyword">const</span> <span class="keywordtype">char</span> * utf8() <span class="keyword">const</span>;
<a name="l00332"></a>00332 
<a name="l00343"></a>00343     <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_array.html">Array&lt;uchar&gt;</a> utf16() <span class="keyword">const</span>;
<a name="l00344"></a>00344 
<a name="l00351"></a>00351     String toLowerCase() <span class="keyword">const</span>;
<a name="l00352"></a>00352 
<a name="l00359"></a>00359     String toUpperCase() <span class="keyword">const</span>;
<a name="l00360"></a>00360 
<a name="l00368"></a>00368     <span class="keywordtype">bool</span> equalsIgnoreCase(<span class="keyword">const</span> String other) <span class="keyword">const</span>;
<a name="l00369"></a>00369 
<a name="l00375"></a>00375     <span class="keywordtype">bool</span> endsWith(<span class="keyword">const</span> String other) <span class="keyword">const</span>;
<a name="l00376"></a>00376 
<a name="l00382"></a>00382     <span class="keywordtype">bool</span> startsWith(<span class="keyword">const</span> String other) <span class="keyword">const</span>;
<a name="l00383"></a>00383 
<a name="l00389"></a>00389     <span class="keywordtype">bool</span> contains(<span class="keyword">const</span> String other) <span class="keyword">const</span>;
<a name="l00390"></a>00390 
<a name="l00396"></a>00396     String trim() <span class="keyword">const</span>;
<a name="l00397"></a>00397 
<a name="l00406"></a>00406     String substring(std::idx_t begin) <span class="keyword">const</span>;
<a name="l00407"></a>00407 
<a name="l00419"></a>00419     String substring(std::idx_t begin, std::idx_t end) <span class="keyword">const</span>;
<a name="l00420"></a>00420 
<a name="l00430"></a>00430     sidx_t indexOf(<span class="keyword">const</span> String substr, idx_t start = 0) <span class="keyword">const</span>;
<a name="l00431"></a>00431 
<a name="l00439"></a>00439     sidx_t lastIndexOf(<span class="keyword">const</span> String substr) <span class="keyword">const</span>;
<a name="l00440"></a>00440 
<a name="l00450"></a>00450     sidx_t lastIndexOf(<span class="keyword">const</span> String substr, idx_t end) <span class="keyword">const</span>;
<a name="l00451"></a>00451 
<a name="l00452"></a>00452     String copy() <span class="keyword">const</span>;
<a name="l00453"></a>00453     <span class="keywordtype">bool</span> merge(String other) <span class="keyword">const</span>;
<a name="l00454"></a>00454 
<a name="l00455"></a>00455     <span class="keyword">static</span> String fromHex(<span class="keywordtype">int</span>, <span class="keywordtype">bool</span> up);
<a name="l00456"></a>00456     <span class="keyword">static</span> String fromOct(<span class="keywordtype">int</span>);
<a name="l00457"></a>00457     <span class="keyword">static</span> String fromSci(<span class="keywordtype">float</span>, <span class="keywordtype">bool</span> up);
<a name="l00458"></a>00458     <span class="keyword">static</span> String fromSci(<span class="keywordtype">double</span>, <span class="keywordtype">bool</span> up);
<a name="l00459"></a>00459 
<a name="l00460"></a>00460     <span class="keywordtype">bool</span> boolValue() <span class="keyword">const</span>;
<a name="l00461"></a>00461     sint intValue() <span class="keyword">const</span>;
<a name="l00462"></a>00462     suint uintValue() <span class="keyword">const</span>;
<a name="l00463"></a>00463     slong longValue() <span class="keyword">const</span>;
<a name="l00464"></a>00464     sulong ulongValue() <span class="keyword">const</span>;
<a name="l00465"></a>00465     <span class="keywordtype">float</span> floatValue() <span class="keyword">const</span>;
<a name="l00466"></a>00466     <span class="keywordtype">double</span> doubleValue() <span class="keyword">const</span>;
<a name="l00467"></a>00467 
<a name="l00468"></a>00468     <span class="keyword">inline</span> <span class="keywordtype">bool</span> toBool()<span class="keyword"> const </span>{
<a name="l00469"></a>00469         <span class="keywordflow">return</span> *<span class="keyword">this</span> != <span class="stringliteral">""</span>;
<a name="l00470"></a>00470     }
<a name="l00471"></a>00471 
<a name="l00472"></a>00472     <span class="keyword">const</span> String &amp; operator=(<span class="keyword">const</span> <span class="keywordtype">char</span> * orig) <span class="keyword">const</span>;
<a name="l00473"></a>00473     <span class="keyword">const</span> String &amp; operator=(<span class="keyword">const</span> std::string &amp; orig) <span class="keyword">const</span>;
<a name="l00474"></a>00474     <span class="keyword">const</span> String &amp; operator=(<span class="keyword">const</span> String orig)<span class="keyword">const</span>;
<a name="l00475"></a>00475 
<a name="l00476"></a>00476     <span class="keyword">const</span> String &amp; operator+=(<span class="keyword">const</span> String rhs)<span class="keyword">const</span>;
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 
<a name="l00486"></a>00486     operator const char *() <span class="keyword">const</span>;
<a name="l00487"></a>00487 
<a name="l00494"></a>00494     operator std::string() <span class="keyword">const</span>;
<a name="l00495"></a>00495 
<a name="l00496"></a>00496 <span class="keyword">private</span>:
<a name="l00497"></a>00497     <span class="keywordtype">void</span> fromAscii(<span class="keyword">const</span> <span class="keywordtype">char</span>* ascii) <span class="keyword">const</span>;
<a name="l00498"></a>00498     <span class="keywordtype">void</span> fromUtf8(<span class="keyword">const</span> <span class="keywordtype">char</span>* unicode) <span class="keyword">const</span>;
<a name="l00499"></a>00499 
<a name="l00500"></a>00500     <span class="keyword">struct </span>Data {
<a name="l00501"></a>00501 
<a name="l00502"></a>00502         Data(<span class="keywordtype">size_t</span> len) : data(len), refcount(1) { }
<a name="l00503"></a>00503 
<a name="l00504"></a>00504         <span class="keyword">virtual</span> ~Data() { }
<a name="l00505"></a>00505         <a class="code" href="class_sylph_1_1_array.html">Array&lt;uchar&gt;</a> data;
<a name="l00506"></a>00506         <span class="keyword">mutable</span> std::size_t refcount;
<a name="l00507"></a>00507     };
<a name="l00508"></a>00508     <span class="keyword">mutable</span> Data * strdata;
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 };
<a name="l00511"></a>00511 
<a name="l00512"></a>00512 <span class="keywordtype">bool</span> <a class="code" href="namespace_sylph.html#10c329a0349416d794bedf8f67feb25f" title="Compares the two Arrays on equality.">operator==</a>(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> lhs, <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> rhs);
<a name="l00513"></a>00513 
<a name="l00514"></a>00514 <span class="keyword">template</span>&lt;&gt;
<a name="l00515"></a>00515 <span class="keyword">struct </span>Hash&lt;<a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a>&gt; {
<a name="l00516"></a>00516 
<a name="l00517"></a>00517     <span class="keyword">inline</span> sint operator()(<a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> s) {
<a name="l00518"></a>00518         suint hash = 0;
<a name="l00519"></a>00519         suint x = 0;
<a name="l00520"></a>00520         suint i = 0;
<a name="l00521"></a>00521         <a class="code" href="namespace_sylph.html#12380d58a638ec489736d7b60963a34c" title="A integral type for storing an UTF-16 character.">uchar</a> * b = s.<a class="code" href="class_sylph_1_1_string.html#59e687b8739e62c6ccf1b0503329dc2f">strdata</a>-&gt;data.carray();
<a name="l00522"></a>00522 
<a name="l00523"></a>00523         <span class="keywordflow">for</span>(i = 0; i &lt; s.<a class="code" href="class_sylph_1_1_string.html#9cc662b15783a2b3310a17ce29b2bf34" title="Returns the length of this String.">length</a>(); b++, i++) {
<a name="l00524"></a>00524             hash = (hash &lt;&lt; 4) + (*b);
<a name="l00525"></a>00525             <span class="keywordflow">if</span>((x = hash &amp; 0xF0000000L) != 0) {
<a name="l00526"></a>00526                 hash ^= (x &gt;&gt; 24);
<a name="l00527"></a>00527             }
<a name="l00528"></a>00528             hash &amp;= ~x;
<a name="l00529"></a>00529         }
<a name="l00530"></a>00530 
<a name="l00531"></a>00531         <span class="keywordflow">return</span> hash;
<a name="l00532"></a>00532     }
<a name="l00533"></a>00533 };
<a name="l00534"></a>00534 
<a name="l00535"></a>00535 <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespace_sylph.html#10c329a0349416d794bedf8f67feb25f" title="Compares the two Arrays on equality.">operator==</a>(<span class="keyword">const</span> String lhs, <span class="keyword">const</span> <span class="keywordtype">char</span>* rhs) {
<a name="l00536"></a>00536     <span class="keywordflow">return</span> <a class="code" href="namespace_sylph.html#10c329a0349416d794bedf8f67feb25f" title="Compares the two Arrays on equality.">operator==</a>(lhs, String(rhs));
<a name="l00537"></a>00537 }
<a name="l00538"></a>00538 
<a name="l00539"></a>00539 <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespace_sylph.html#10c329a0349416d794bedf8f67feb25f" title="Compares the two Arrays on equality.">operator==</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* rhs, <span class="keyword">const</span> String lhs) {
<a name="l00540"></a>00540     <span class="keywordflow">return</span> <a class="code" href="namespace_sylph.html#10c329a0349416d794bedf8f67feb25f" title="Compares the two Arrays on equality.">operator==</a>(String(rhs), lhs);
<a name="l00541"></a>00541 }
<a name="l00542"></a>00542 <span class="keywordtype">bool</span> <a class="code" href="namespace_sylph.html#049ea1ef37b015ca0292637e6d2e3ffa" title="Compares the two Arrays.">operator&lt;</a>(<span class="keyword">const</span> String lhs, <span class="keyword">const</span> String rhs);
<a name="l00543"></a>00543 String operator+(<span class="keyword">const</span> String lhs, <span class="keyword">const</span> String rhs);
<a name="l00544"></a>00544 <span class="comment">//String operator%(const String lhs, const String rhs);</span>
<a name="l00545"></a>00545 String operator&amp;(<span class="keyword">const</span> String lhs, String(*rhs)(<span class="keyword">const</span> String));
<a name="l00546"></a>00546 String operator&amp;(String(*lhs)(<span class="keyword">const</span> String), <span class="keyword">const</span> String rhs);
<a name="l00547"></a>00547 String operator*(<span class="keyword">const</span> String lhs, <span class="keyword">const</span> std::size_t len);
<a name="l00548"></a>00548 std::ostream &amp; operator&lt;&lt;(std::ostream&amp; lhs, <span class="keyword">const</span> String rhs);
<a name="l00549"></a>00549 
<a name="l00550"></a>00550 String lc(<span class="keyword">const</span> String rhs);
<a name="l00551"></a>00551 String uc(<span class="keyword">const</span> String rhs);
<a name="l00552"></a>00552 String t(<span class="keyword">const</span> String rhs);
<a name="l00553"></a>00553 
<a name="l00554"></a>00554 SYLPH_END_NAMESPACE
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 <span class="preprocessor">#endif </span><span class="comment">/* STRING_H_ */</span>
</pre></div></div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
